"""common func for object detection visualize
"""


from itertools import cycle, islice
import cv2_imgproc as cv2_imgproc


def bbox2ltrb(bbox):
    x, y, w, h = bbox
    return (x, y), (x+w, y+h)

def bboxVisualize(
    src,
    bboxes,
    landmarks_of_bbox = None,
    color = (0, 255, 0),
    landmark_colors = [(0, 255, 0)],
    thickness = None
) :
    landmarks_of_bbox = landmarks_of_bbox if landmarks_of_bbox is not None else [
        [] for _ in range(len(bboxes))]
    assert len(bboxes) == len(landmarks_of_bbox)
    dst = src.copy()
    for bbox, landmarks in zip(bboxes, landmarks_of_bbox):
        dst[:] = cv2_imgproc.rectangle(dst, *bbox2ltrb(bbox), color, thickness)
        for lm, l_color in zip(landmarks, islice(cycle(landmark_colors), len(landmarks))):
            dst[:] = cv2_imgproc.circle(dst, tuple(lm), color=l_color)
    return dst
